import { CallEffectDescriptor, Effect, Promisify, CoFn, DelayEffectDescriptor, NextFn, EffectHandler, AllEffectDescriptor, RaceEffectDescriptor } from './types';
export declare const typeDetector: (type: string) => (value: any) => boolean;
export declare const CALL = "CALL";
export declare function call<Fn extends (...args: any[]) => any>(fn: Fn, ...args: Parameters<Fn>): CallEffectDescriptor;
export declare function call<Ctx extends {
    [P in Name]: (this: Ctx, ...args: any[]) => any;
}, Name extends string>(ctxAndFnName: [Ctx, Name], ...args: Parameters<Ctx[Name]>): CallEffectDescriptor;
export declare const ALL = "ALL";
export declare function all<T>(effects: T[]): AllEffectDescriptor<T>;
export declare function all<T>(effects: {
    [key: string]: T;
}): AllEffectDescriptor<T>;
export declare const RACE = "RACE";
export declare function race<T>(effects: T[]): RaceEffectDescriptor<T>;
export declare function race<T>(effects: {
    [key: string]: T;
}): RaceEffectDescriptor<T>;
declare type Fn = (...args: any[]) => any;
export declare const FORK = "FORK";
export declare const fork: (fn: any[] | Fn, ...args: any[]) => {
    type: string;
    fn: any[] | Fn;
    args: any[];
};
export declare const SPAWN = "SPAWN";
export declare const spawn: (fn: CoFn<any>, ...args: any[]) => {
    type: string;
    fn: CoFn<any>;
    args: any[];
};
export declare const DELAY = "DELAY";
export declare const delay: (ms: number) => DelayEffectDescriptor;
export declare function effectHandler(this: any, { effect, promisify, cancel }: EffectHandler): any;
export declare function effectMiddleware(next: NextFn): (effect: Effect, promisify: Promisify, cancel: Promise<any>) => import("./types").Middleware;
export {};
