"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var noop = function () { };
function speculation(fn, cancel) {
    return new Promise(function (_resolve, _reject) {
        var isSettled = false;
        var resolve = function (input) {
            isSettled = true;
            _resolve(input);
        };
        var reject = function (input) {
            isSettled = true;
            _reject(input);
        };
        var onCancel = function (handleCancel) {
            var maybeHandleCancel = function (value) {
                if (!isSettled) {
                    handleCancel(value);
                }
            };
            if (!cancel) {
                return Promise.resolve();
            }
            return (cancel
                .then(maybeHandleCancel, noop)
                .catch(reject));
        };
        fn(resolve, reject, onCancel);
    });
}
exports.default = speculation;
//# sourceMappingURL=speculation.js.map