export declare type Fn = (...args: any[]) => void;
export declare type GenFn<V = any> = (...args: any[]) => IterableIterator<V>;
export declare type CoFn<V = any> = GenFn<V> | Fn;
export declare type TaskFn<V> = (fn: CoFn<V>, ...args: any[]) => Promise<any>;
export interface CallEffectDescriptor {
    type: 'CALL';
    fn: Fn | any[];
    args: any[];
}
export interface SpawnEffectDescriptor {
    type: 'SPAWN';
    fn: Fn;
    args: any[];
}
export interface DelayEffectDescriptor {
    type: 'DELAY';
    ms: number;
}
export interface RaceEffectDescriptor<T> {
    type: 'RACE';
    effects: AllEffect<T>;
}
export interface AllEffectDescriptor<T> {
    type: 'ALL';
    effects: AllEffect<T>;
}
export declare type AllEffect<T> = T[] | {
    [key: string]: T;
};
export declare type Effect = CallEffectDescriptor | SpawnEffectDescriptor | DelayEffectDescriptor;
export declare type CombinatorEffect<T> = RaceEffectDescriptor<T> | AllEffectDescriptor<T>;
export declare type NextFn = (...args: any[]) => Middleware;
export declare type Promisify = (p: any, cancel?: Promise<any>) => Promise<any>;
export declare type Middleware = (next: NextFn) => (effect: Effect, promisify: Promisify, cancelPromise: Promise<any>) => Middleware;
export interface EffectHandler {
    effect: any;
    promisify: Promisify;
    cancel: Promise<any>;
}
